#! /usr/bin/env python
#own modules

#standard modules
import pygtk
import gtk
import gtk.glade
import gobject
pygtk.require("2.0")

class Window_log:
	def __init__(self,downloader):
		self.downloader = downloader
		self.wTree = gtk.glade.XML( "sfdownloader.glade","window_log")
		self.callbacks = {"on_button_close_clicked":self.__callback_button_close_clicked}
		self.wTree.signal_autoconnect (self.callbacks)
		self.fill_list()

	def fill_list(self):
		log = self.wTree.get_widget("list_log")
		log_list_model = gtk.TreeStore(gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING)
		log.set_model(log_list_model)
		renderer = gtk.CellRendererText()
		column = gtk.TreeViewColumn(_("Timestamp"), renderer, text=0)
		column.set_min_width(40)
		column.set_resizable(True)
		log.append_column(column)
		renderer = gtk.CellRendererText()
		column = gtk.TreeViewColumn(_("Type"), renderer, text=1)
		column.set_min_width(50)
		column.set_resizable(True)
		log.append_column(column)
		renderer = gtk.CellRendererText()
		column = gtk.TreeViewColumn(_("Message"), renderer, text=2)
		column.set_min_width(150)
		column.set_resizable(True)
		log.append_column(column)
		types = {0:_("Information"),1:_("Warning"),2:_("Error"),3:_("Debug")}
		for x in self.downloader.log_list:
			log_list_model.set(log_list_model.append(None),0,str(x[0]),1,types[x[1]],2,x[2])

	#callbacks
	def __callback_button_close_clicked(self,widget):
		self.wTree.get_widget("window_log").destroy()
